Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 835661

Summary: media-gfx/inkscape-9999 fails to compile with new poppler: error: no matching function for call to ‘PDFDoc::PDFDoc(GooString*&, std::nullptr_t, std::nullptr_t, std::nullptr_t)’
Product: Gentoo Linux Reporter: Miroslav Šulc <fordfrog>
Component: Current packagesAssignee: Mikle Kolyada <zlogene>
Status: RESOLVED FIXED    
Severity: normal CC: dilfridge, harleyw, harrisl, sam
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
See Also: https://bugs.gentoo.org/show_bug.cgi?id=843275
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 843317    
Attachments: build.log

Description Miroslav Šulc gentoo-dev 2022-03-20 13:41:25 UTC
Created attachment 767444 [details]
build.log

/usr/lib/gcc/x86_64-pc-linux-gnu/11.2.1/include/g++-v11/ext/new_allocator.h:162:11: error: no matching function for call to ‘PDFDoc::PDFDoc(GooString*&, std::nullptr_t, std::nullptr_t, std::nullptr_t)’
  162 |         { ::new((void *)__p) _Up(std::forward<_Args>(__args)...); }


# emerge --info '=media-gfx/inkscape-9999::gentoo'
Portage 3.0.30 (python 3.9.11-final-0, default/linux/amd64/17.1/hardened, gcc-11.2.1, glibc-2.34-r10, 5.16.16-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-5.16.16-gentoo-x86_64-Intel-R-_Core-TM-_i7-10875H_CPU_@_2.30GHz-with-glibc2.34
KiB Mem:    32652772 total,   5212484 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Sun, 20 Mar 2022 10:00:01 +0000
Head commit of repository gentoo: 1eba47e37b1652288e36eead49460ad997b728b4
sh bash 5.1_p16
ld GNU ld (Gentoo 2.37_p1 p2) 2.37
app-misc/pax-utils:        1.3.3::gentoo
app-shells/bash:           5.1_p16::gentoo
dev-java/java-config:      2.3.1::gentoo
dev-lang/perl:             5.34.1::gentoo
dev-lang/python:           2.7.18_p15::gentoo, 3.8.13::gentoo, 3.9.11::gentoo, 3.10.3::gentoo
dev-lang/rust:             1.59.0::gentoo
dev-util/cmake:            3.22.3::gentoo
dev-util/meson:            0.61.3::gentoo
sys-apps/baselayout:       2.8::gentoo
sys-apps/openrc:           0.44.10::gentoo
sys-apps/sandbox:          2.29::gentoo
sys-devel/autoconf:        2.13-r1::gentoo, 2.71-r1::gentoo
sys-devel/automake:        1.16.5::gentoo
sys-devel/binutils:        2.37_p1-r2::gentoo, 2.38-r1::gentoo
sys-devel/binutils-config: 5.4.1::gentoo
sys-devel/clang:           13.0.1::gentoo
sys-devel/gcc:             11.2.1_p20220115::gentoo
sys-devel/gcc-config:      2.5-r1::gentoo
sys-devel/libtool:         2.4.6-r6::gentoo
sys-devel/lld:             13.0.1::gentoo
sys-devel/llvm:            13.0.1::gentoo
sys-devel/make:            4.3::gentoo
sys-kernel/linux-headers:  5.16::gentoo (virtual/os-headers)
sys-libs/glibc:            2.34-r10::gentoo
Repositories:

gentoo
    location: /var/db/repos/gentoo
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-metamanifest: yes
    sync-rsync-extra-opts: 

brother-overlay
    location: /var/lib/layman/brother-overlay
    masters: gentoo
    priority: 50

ceamac
    location: /var/lib/layman/ceamac
    masters: gentoo
    priority: 50

flavour
    location: /var/lib/layman/flavour
    masters: gentoo
    priority: 50

fordfrog
    location: /var/lib/layman/fordfrog
    masters: gentoo
    priority: 50

waebbl
    location: /var/lib/layman/waebbl
    masters: gentoo
    priority: 50

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe -frecord-gcc-switches"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /opt/brother/scanner/brscan4/brsanenetdevice4.cfg /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/maven-bin-3.8/conf"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=native -O2 -pipe -frecord-gcc-switches"
DISTDIR="/var/db/repos/gentoo/distfiles"
EMERGE_DEFAULT_OPTS="--misspell-suggestions n"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-march=native -O2 -pipe -frecord-gcc-switches"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs binpkg-multi-instance buildpkg-live config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-march=native -O2 -pipe -frecord-gcc-switches"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="cs_CZ.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="cs cs_CZ en en_US en_UK"
MAKEOPTS="-j17"
PKGDIR="/var/db/repos/gentoo/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
SHELL="/bin/bash"
USE="X a52 aac aacplus acl alsa amd64 aubio bluetooth bzip2 cdda cddb cdr color-management colord crypt cuda cups dbus dia dssi dvb dvd elogind exif ffmpeg flac gegl gif gphoto2 gsm gtk gtk3 hardened hddtemp http2 ibus iconv icu id3tag ipv6 jack jack-dbus jacksession javafx jpeg ladspa lastfm latex lcms libass libglvnd libnotify libproxy libsamplerate libtirpc lilypond lm-sensors lv2 mad modplug mp3 mpeg mpi mtp multilib musepack ncurses nls nptl ocr ogg openexr opengl openmp opus osc pam pcre pdf pie png policykit pulseaudio qt5 raw readline rubberband samba scanner screencast seccomp sf2 sndfile soundio speex spell split-usr ssl ssp startup-notification svg svg2 taglib theora tiff timidity tk tray truetype udev unicode usb vamp visio vorbis vpx vst vulkan wavpack webp widevine wmf x264 x265 xattr xinerama xmp xtpax xv xvid zlib" ABI_X86="32 64" ADA_TARGET="gnat_2020" APACHE2_MODULES="alias auth_basic authn_core authn_file authz_core authz_host authz_user cgi cgid deflate dir expires filter headers http2 include info log_config mime mime_magic negotiation proxy proxy_ajp rewrite setenvif socache_shmcb status unixd vhost_alias" APACHE2_MPMS="event" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 f16c fma3 mmx mmxext pclmul popcnt rdrand sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev libinput synaptics wacom" KERNEL="linux" L10N="cs cs-CZ en en-US en-UK" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LLVM_TARGETS="NVPTX" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-4 php8-0" POSTGRES_TARGETS="postgres12 postgres13" PYTHON_SINGLE_TARGET="python3_9" PYTHON_TARGETS="python3_6 python3_7 python3_8 python3_9" RUBY_TARGETS="ruby26 ruby27 ruby30" SANE_BACKENDS="genesys" USERLAND="GNU" VIDEO_CARDS="intel i915 i965 nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  ADDR2LINE, AR, ARFLAGS, AS, ASFLAGS, CC, CCLD, CONFIG_SHELL, CPP, CPPFLAGS, CTARGET, CXX, CXXFILT, ELFEDIT, EXTRA_ECONF, F77FLAGS, FC, GCOV, GPROF, INSTALL_MASK, LC_ALL, LD, LEX, LFLAGS, LIBTOOL, MAKE, MAKEFLAGS, NM, OBJCOPY, OBJDUMP, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RANLIB, READELF, RUSTFLAGS, SIZE, STRINGS, STRIP, YACC, YFLAGS

=================================================================
                        Package Settings
=================================================================

media-gfx/inkscape-9999::gentoo was built with the following:
USE="cdr dbus dia exif graphicsmagick imagemagick inkjar jpeg openmp postscript readline spell svg2 visio (-jemalloc) -test -wpg" ABI_X86="(64)" PYTHON_SINGLE_TARGET="python3_9 -python3_10 -python3_8"
CFLAGS="-march=native -O2 -pipe -frecord-gcc-switches -fno-strict-aliasing"
CXXFLAGS="-march=native -O2 -pipe -frecord-gcc-switches -fno-strict-aliasing"
FEATURES="preserve-libs ipc-sandbox config-protect-if-modified network-sandbox binpkg-dostrip binpkg-logs multilib-strict ebuild-locks news userpriv fixlafiles pid-sandbox xattr unknown-features-warn protect-owned assume-digests buildpkg-live strict usersync userfetch usersandbox unmerge-logs binpkg-multi-instance sandbox parallel-fetch binpkg-docompress unmerge-orphans distlocks sfperms qa-unresolved-soname-deps merge-sync"


# emerge -pqv '=media-gfx/inkscape-9999::gentoo'
[ebuild   R   ] media-gfx/inkscape-9999  USE="cdr dbus dia exif graphicsmagick imagemagick inkjar jpeg openmp postscript readline spell svg2 visio (-jemalloc) -test -wpg" PYTHON_SINGLE_TARGET="python3_9 -python3_8 -python3_10"
Comment 1 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-03-20 16:34:31 UTC
THe patch isn't upstream yet so it's in release ebuilds but not 9999.
Comment 2 Harley Wiltzer 2022-04-18 14:36:24 UTC
I'm getting this same error when trying to build inkscape-1.1-r1 today.
Comment 3 Markus Peloquin 2022-04-19 22:56:04 UTC
I'm getting this with Clang w/libc++. My error is a bit different so for the sake of search results:

  error: no matching constructor for initialization of 'PDFDoc'

These commits (introduced in Poppler 22.03.0) changed the PDFDoc constructors:
https://github.com/freedesktop/poppler/commit/07889cdfd8a261dc5ae6eb72c26a8a3ec2e35930
https://github.com/freedesktop/poppler/commit/4f2abd3efa1ee013d7e672bad5a2fe58610cdc1d
Comment 5 Larry the Git Cow gentoo-dev 2022-05-08 17:42:25 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=ea7abbfe5d1f6fbe2f25979b00e3d36651e0a041

commit ea7abbfe5d1f6fbe2f25979b00e3d36651e0a041
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2022-05-08 17:41:15 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2022-05-08 17:42:19 +0000

    media-gfx/inkscape: fix build with Poppler 22.04.0
    
    Also, switch out the 22.03.0 patch with the variant in upstream's
    1.1.x branch so that 22.04.x patch applies (from same place).
    
    Closes: https://bugs.gentoo.org/843275
    Closes: https://bugs.gentoo.org/835661
    Bug: https://bugs.gentoo.org/835424
    Signed-off-by: Sam James <sam@gentoo.org>

 .../files/inkscape-1.1.2-r1-poppler-22.03.0.patch  |  43 +++++
 .../files/inkscape-1.1.2-r1-poppler-22.04.0.patch  | 130 +++++++++++++++
 media-gfx/inkscape/inkscape-1.1.2-r1.ebuild        | 184 +++++++++++++++++++++
 3 files changed, 357 insertions(+)